<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.dk.mdm.mapper.mst.CusFollowMapper">

    <!-- 通用设置 -->
    <!-- 通用查询列 -->
    <sql id="Base_Column_List">
        follow_id, cus_id, follow_status, follow_org, follow_staff, follow_time, follow_data, follow_time_len, stay_time_len, intention, invite_result, invite_time, design_staff, next_follow_plan, next_follow_time, annex_paths, measure_status, remarks, flg_valid, cp_id, op_create_time, op_create_user_id, op_update_time, op_update_user_id, op_app_code, op_timestamp, op_db_user
    </sql>
    <sql id="Base_Column_List_Join">
        tccf.follow_id, tccf.cus_id, tccf.follow_status,tccf.follow_type,  tccf.follow_org, tccf.follow_staff, tccf.follow_time, tccf.follow_data,
                 tccf.follow_time_len, tccf.stay_time_len, tccf.intention, tccf.invite_result, tccf.invite_time, tccf.design_staff,
                 tccf.next_follow_plan, tccf.next_follow_time,tccf.annex_paths, tccf.measure_status, tccf.remarks, tccf.flg_valid,
                 tccf.cp_id
    </sql>
    <!-- 通用查询映射结果 -->
    <resultMap id="BaseResultMap" type="com.dk.mdm.model.pojo.mst.CusFollow">
        <id column="follow_id" property="followId"/>
                <result column="cus_id" property="cusId" typeHandler="UuidTypeHandler"/>
                <result column="follow_status" property="followStatus"/>
                <result column="follow_org" property="followOrg" typeHandler="UuidTypeHandler"/>
                <result column="follow_staff" property="followStaff" typeHandler="UuidTypeHandler"/>
            <result column="follow_time" property="followTime" typeHandler="TimestampTypeHandler"/>
                <result column="follow_data" property="followData"/>
                <result column="follow_time_len" property="followTimeLen"/>
                <result column="stay_time_len" property="stayTimeLen"/>
                <result column="intention" property="intention"/>
                <result column="invite_result" property="inviteResult"/>
            <result column="invite_time" property="inviteTime" typeHandler="TimestampTypeHandler"/>
                <result column="design_staff" property="designStaff" typeHandler="UuidTypeHandler"/>
                <result column="next_follow_plan" property="nextFollowPlan"/>
            <result column="next_follow_time" property="nextFollowTime" typeHandler="TimestampTypeHandler"/>
                <result column="annex_paths" property="annexPaths" typeHandler="JsonTypeHandler"/>
                <result column="measure_status" property="measureStatus"/>
                <result column="remarks" property="remarks"/>
                <result column="flg_valid" property="flgValid"/>
                <result column="cp_id" property="cpId"/>
            <result column="op_create_time" property="opCreateTime" typeHandler="TimestampTypeHandler"/>
                <result column="op_create_user_id" property="opCreateUserId" typeHandler="UuidTypeHandler"/>
            <result column="op_update_time" property="opUpdateTime" typeHandler="TimestampTypeHandler"/>
                <result column="op_update_user_id" property="opUpdateUserId" typeHandler="UuidTypeHandler"/>
                <result column="op_app_code" property="opAppCode"/>
            <result column="op_timestamp" property="opTimestamp" typeHandler="TimestampTypeHandler"/>
                <result column="op_db_user" property="opDbUser"/>
    </resultMap>
    <resultMap id="BaseResultMapResponse" type="com.dk.mdm.model.response.mst.CusFollowResponse">
        <id column="follow_id" property="followId"/>
        <result column="cus_id" property="cusId" typeHandler="UuidTypeHandler"/>
        <result column="follow_status" property="followStatus"/>
        <result column="follow_type" property="followType"/>
        <result column="follow_org" property="followOrg" typeHandler="UuidTypeHandler"/>
        <result column="follow_staff" property="followStaff" typeHandler="UuidTypeHandler"/>
        <result column="follow_time" property="followTime" typeHandler="TimestampTypeHandler"/>
        <result column="follow_data" property="followData"/>
        <result column="follow_time_len" property="followTimeLen"/>
        <result column="stay_time_len" property="stayTimeLen"/>
        <result column="intention" property="intention"/>
        <result column="invite_result" property="inviteResult"/>
        <result column="invite_time" property="inviteTime" typeHandler="TimestampTypeHandler"/>
        <result column="design_staff" property="designStaff" typeHandler="UuidTypeHandler"/>
        <result column="next_follow_plan" property="nextFollowPlan"/>
        <result column="next_follow_time" property="nextFollowTime" typeHandler="TimestampTypeHandler"/>
        <result column="annex_paths" property="annexPaths" typeHandler="JsonTypeHandler"/>
        <result column="measure_status" property="measureStatus"/>
        <result column="remarks" property="remarks"/>
        <result column="flg_valid" property="flgValid"/>
        <result column="cp_id" property="cpId"/>
        <result column="sale_status" property="saleStatus"/>
        <result column="channel_id" property="channelId"/>
        <result column="cusName" property="cusName"/>
        <result column="cusCode" property="cusCode"/>
        <result column="cusPhone" property="cusPhone"/>
        <result column="orgName" property="orgName"/>
        <result column="staffName" property="staffName"/>
        <result column="follow_count" property="followCount"/>
        <result column="follow_staff_name" property="followStaffName"/>
        <result column="create_time" property="createTime"  typeHandler="TimestampTypeHandler"/>
        <result column="follow_status_name" property="followStatusName"/>
        <result column="cus_name" property="cusName"/>
        <result column="cus_code" property="cusCode"/>
        <result column="cus_phone" property="cusPhone"/>
        <result column="address_full" property="addressFull"/>
        <result column="address_no" property="addressNo"/>
        <result column="address_name" property="addressName"/>
        <result column="intention_name" property="intentionName"/>
        <result column="stay_time_len_name" property="stayTimeLenName"/>
        <result column="address_area" property="addressArea" typeHandler="JsonTypeHandler"/>
        <result column="address_gcj02" property="addressGcj02" typeHandler="JsonTypeHandler"/>



    </resultMap>

    <!-- 通用条件列 -->
      <sql id="Condition">
        <where>
            <if test="cusId != null and cusId != ''">
                AND cus_id = #{cusId}
            </if>
            <if test="followStatus != null and followStatus != ''">
                AND follow_status = #{followStatus}
            </if>

            <if test="followOrg != null and followOrg != ''">
                AND follow_org = #{followOrg}
            </if>
            <if test="followStaff != null and followStaff != ''">
                AND follow_staff = #{followStaff}
            </if>
            <if test="followTime != null">
                AND follow_time = #{followTime}
            </if>
            <if test="followData != null and followData != ''">
                AND follow_data = #{followData}
            </if>
            <if test="followTimeLen != null">
                AND follow_time_len = #{followTimeLen}
            </if>
            <if test="stayTimeLen != null and stayTimeLen != ''">
                AND stay_time_len = #{stayTimeLen}
            </if>
            <if test="intention != null and intention != ''">
                AND intention = #{intention}
            </if>
            <if test="inviteResult != null and inviteResult != ''">
                AND invite_result = #{inviteResult}
            </if>
            <if test="inviteTime != null">
                AND invite_time = #{inviteTime}
            </if>
            <if test="designStaff != null and designStaff != ''">
                AND design_staff = #{designStaff}
            </if>
            <if test="nextFollowPlan != null and nextFollowPlan != ''">
                AND next_follow_plan = #{nextFollowPlan}
            </if>
            <if test="nextFollowTime != null">
                AND next_follow_time = #{nextFollowTime}
            </if>
            <if test="annexPaths != null and annexPaths != ''">
                AND annex_paths = #{annexPaths}
            </if>
            <if test="measureStatus != null and measureStatus != ''">
                AND measure_status = #{measureStatus}
            </if>
            <if test="remarks != null and remarks != ''">
                AND remarks = #{remarks}
            </if>
            <if test="flgValid != null">
                AND flg_valid = #{flgValid}
            </if>
            <if test="cpId != null">
                AND cp_id = #{cpId}
            </if>
            <if test="opCreateTime != null">
                AND op_create_time = #{opCreateTime}
            </if>
            <if test="opCreateUserId != null and opCreateUserId != ''">
                AND op_create_user_id = #{opCreateUserId}
            </if>
            <if test="opUpdateTime != null">
                AND op_update_time = #{opUpdateTime}
            </if>
            <if test="opUpdateUserId != null and opUpdateUserId != ''">
                AND op_update_user_id = #{opUpdateUserId}
            </if>
            <if test="opAppCode != null and opAppCode != ''">
                AND op_app_code = #{opAppCode}
            </if>
            <if test="opTimestamp != null">
                AND op_timestamp = #{opTimestamp}
            </if>
            <if test="opDbUser != null and opDbUser != ''">
                AND op_db_user = #{opDbUser}
            </if>
        </where>
    </sql>

    <sql id="Condition_Join">
        <where>
            <if test="cusId != null and cusId != ''">
                AND tccf.cus_id = #{cusId}::uuid
            </if>
            <if test="followStatus != null and followStatus != ''">
                AND tccf.follow_status = #{followStatus}
            </if>
            <if test="followId != null and followId != ''">
                AND tccf.follow_id = #{followId}::uuid
            </if>

            <if test="followOrg != null and followOrg != ''">
                AND tccf.follow_org = #{followOrg}
            </if>
            <if test="followStaff != null and followStaff != ''">
                AND tccf.follow_staff = #{followStaff}
            </if>
            <if test="followTime != null">
                AND tccf.follow_time = #{followTime}
            </if>
            <if test="followData != null and followData != ''">
                AND tccf.follow_data = #{followData}
            </if>
            <if test="followTimeLen != null">
                AND tccf.follow_time_len = #{followTimeLen}
            </if>
            <if test="stayTimeLen != null and stayTimeLen != ''">
                AND tccf.stay_time_len = #{stayTimeLen}
            </if>
            <if test="intention != null and intention != ''">
                AND tccf.intention = #{intention}
            </if>
            <if test="inviteResult != null and inviteResult != ''">
                AND tccf.invite_result = #{inviteResult}
            </if>
            <if test="inviteTime != null">
                AND tccf.invite_time = #{inviteTime}
            </if>
            <if test="designStaff != null and designStaff != ''">
                AND tccf.design_staff = #{designStaff}
            </if>
            <if test="nextFollowPlan != null and nextFollowPlan != ''">
                AND tccf.next_follow_plan = #{nextFollowPlan}
            </if>
<!--            <if test="nextFollowTime != null">-->
<!--                AND tccf.next_follow_time = #{nextFollowTime}-->
<!--            </if>-->
            <if test="annexPaths != null and annexPaths != ''">
                AND tccf.annex_paths = #{annexPaths}
            </if>
            <if test="measureStatus != null and measureStatus != ''">
                AND tccf.measure_status = #{measureStatus}
            </if>
            <if test="remarks != null and remarks != ''">
                AND tccf.remarks = #{remarks}
            </if>
            <if test="flgValid != null">
                AND tccf.flg_valid = #{flgValid}
            </if>
            <if test="cpId != null">
                AND tccf.cp_id = #{cpId}
            </if>
            <if test="staffIds != null and staffIds.size()>0">
                AND tccf.follow_staff =
                any(#{staffIds, typeHandler=StringListTypeHandler})
            </if>
            <if test="followStatusList != null and followStatusList.size()>0">
                AND tccf.follow_status =
                any(#{followStatusList, typeHandler=StringListTypeHandler})
            </if>

            <if test="createtimeStart != null and createtimeEnd != null">
                AND tccf.op_create_time &gt;= #{createtimeStart}::timestamp with time zone
                AND tccf.op_create_time &lt; #{createtimeEnd}::timestamp with time zone + interval '1 day'
            </if>
            <if test="nextFollowTimeStart != null and nextFollowTimeEnd != null">
                AND tccf.next_follow_time &gt;= #{nextFollowTimeStart}::timestamp with time zone
                AND tccf.next_follow_time &lt; #{nextFollowTimeEnd}::timestamp with time zone + interval '1 day'
            </if>
            <if test="searchText != null and searchText != ''">
                AND(tmc.cus_phone  LIKE concat('%', #{searchText}, '%')
                OR tmc.cus_name LIKE concat('%', #{searchText}, '%')
                OR tmc.address_full LIKE concat('%', #{searchText}, '%')
                OR tccf.remarks LIKE concat('%', #{searchText}, '%')
                )
            </if>
        </where>
    </sql>

    <sql id="idsForeach">
        <!-- 根据主键followId批量操作 -->
        WHERE follow_id in
        <foreach collection="ids" index="index" item="item" separator="," open="(" close=")">
            #{item}
        </foreach>
    </sql>

    <!-- 查询表t_crm_cus_follow，（条件查询+分页）列表 -->
    <select id="selectByCond" resultMap="BaseResultMapResponse">
        SELECT
        <include refid="Base_Column_List_Join"/>,
        (CASE
        WHEN tccf.follow_status = '跟进状态-接待' THEN '无联系人'
        ELSE tmc.cus_name END ) AS cus_name,
        tmc.cus_code as cus_code,
        tmc.cus_phone AS cus_phone,
        tmc.sale_status AS sale_status,
        tmc.channel_id AS channel_id,
        tmc.address_full AS address_full,
        tmc.address_area AS address_area,
        tmc.address_gcj02 AS address_gcj02,
        tmc.address_name AS address_name,
        tmc.address_no AS address_no,
        tmo.org_name AS "orgName",
        tms.staff_name AS "staffName",
        tmc.follow_count AS follow_count,
        tdk1.kind_name_i18n ->>  #{i18n} AS "follow_status_name",
        tdk2.kind_name_i18n ->>  #{i18n} AS intention_name,
        tdk3.kind_name_i18n ->>  #{i18n} AS stay_time_len_name

        FROM dkic_b.t_crm_cus_follow tccf
        LEFT JOIN dkic_b.t_mst_customer tmc ON tmc.cus_id = tccf.cus_id
        LEFT JOIN dkic_b.t_mst_org tmo on tmo.org_id = tccf.follow_org
        LEFT JOIN dkic_b.t_mst_staff tms on tms.staff_id = tccf.follow_staff
        LEFT JOIN sys.t_data_kind tdk1 on tdk1.kind_code = tccf.follow_status
        LEFT JOIN sys.t_data_kind tdk2 on tdk2.kind_code = tccf.intention
        LEFT JOIN sys.t_data_kind tdk3 on tdk3.kind_code = tccf.stay_time_len
        <include refid="Condition_Join"/>
        order by  tccf.follow_time desc
        <if test="pageSize != null and currentPage != null and pageSize != 0 and currentPage != 0">
            limit #{end} offset #{start}
        </if>
    </select>

<!--查询跟进记录-->
    <select id="selectByList" resultMap="BaseResultMapResponse">
        SELECT
        <include refid="Base_Column_List_Join"/>,
        tmc.cus_name AS "cusName",
        tmc.cus_code as "cusCode",
        tmc.cus_phone AS "cusPhone",
        tmc.address_full AS "addressFull",
        tmo.org_name  AS  "orgName",
        tms.staff_name  AS  "staffName",
        tmc.follow_count AS follow_count,
        tms.staff_name AS follow_staff_name,
        tccf.op_create_time AS create_time,
        tdk1.kind_name_i18n  ->>  #{i18n} AS "follow_status_name"
        FROM dkic_b.t_crm_cus_follow tccf
        LEFT JOIN dkic_b.t_mst_customer tmc ON tmc.cus_id = tccf.cus_id
        LEFT JOIN dkic_b.t_mst_org tmo on tmo.org_id = tccf.follow_org
        LEFT JOIN dkic_b.t_mst_staff tms on tms.staff_id = tccf.follow_staff

        LEFT JOIN  sys.t_data_kind tdk1  on tdk1.kind_code =  tccf.follow_status

        <include refid="Condition_Join"/>

    </select>

    <!-- 查询表t_crm_cus_follow，（条件查询）个数 -->
    <select id="countByCond" resultType="Long">
        SELECT
        count(1)
        FROM dkic_b.t_crm_cus_follow tccf
        LEFT JOIN dkic_b.t_mst_customer tmc ON tmc.cus_id = tccf.cus_id
        <include refid="Condition_Join"/>
    </select>

    <!-- 根据主键查询表t_crm_cus_follow的一行数据 -->
    <select id="selectById" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM dkic_b.t_crm_cus_follow
        WHERE follow_id = #{id}::uuid
    </select>

    <!-- 根据主键锁定表t_crm_cus_follow的一行数据 -->
    <select id="selectByIdForUpdate" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM dkic_b.t_crm_cus_follow
        WHERE follow_id = #{followId}
        for update
    </select>

    <!-- 根据主键锁定表t_crm_cus_follow的多行数据 -->
    <select id="selectByIdsForUpdate" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM dkic_b.t_crm_cus_follow
        <include refid="idsForeach"/>
        for update
    </select>

    <insert id="insertBatch">
        insert into dkic_b.t_crm_cus_follow
        (
        <trim suffixOverrides=",">
            cus_id,
            follow_status,
            follow_org,
            follow_staff,
            follow_time,
            follow_data,
            follow_time_len,
            stay_time_len,
            intention,
            invite_result,
            invite_time,
            design_staff,
            next_follow_plan,
            next_follow_time,
            annex_paths,
            measure_status,
            remarks,
            cp_id,
            op_app_code,
        </trim>
        )
        values
        <foreach collection="list" index="index" item="item" separator=",">
            (
            <trim suffixOverrides=",">
                #{item.cusId}::uuid,
                #{item.followStatus},
                #{item.followOrg}::uuid,
                #{item.followStaff}::uuid,
                #{item.followTime},
                #{item.followData},
                #{item.followTimeLen},
                #{item.stayTimeLen},
                #{item.intention},
                #{item.inviteResult},
                #{item.inviteTime},
                #{item.designStaff}::uuid,
                #{item.nextFollowPlan},
                #{item.nextFollowTime},
                #{item.annexPaths},
                #{item.measureStatus},
                #{item.remarks},
                #{item.cpId},
                #{item.opAppCode},
            </trim>
            )
        </foreach>
    </insert>

</mapper>
